// ResizableTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ResizableTest.h"
#include "ResizableTestDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public TXResizable<CDialog>
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	virtual UINT GetResizeFlags(UINT id,CWnd* pControl,CRect& rcControl, const CSize& szNow, const CSize& szWas, const CSize& szIni, const CSize& szDelta);

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
  afx_msg void OnBnClickedOk();
};

CAboutDlg::CAboutDlg() : TXResizable<CDialog>(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

UINT CAboutDlg::GetResizeFlags(UINT id,CWnd* /*pControl*/,CRect& /*rcControl*/, const CSize& /*szNow*/, const CSize& /*szWas*/, const CSize& /*szIni*/, const CSize& /*szDelta*/) {
	if (id == IDOK) {
		return RESIZE_WIDTH_RFIX | RESIZE_HEIGHT_TFIX;
	} else {
		return RESIZE_PROP;
	}
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	TXResizable<CDialog>::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

void CAboutDlg::OnBnClickedOk()
{
	CWaitCursor wait;

  CString strUrl = "http://www.thecodechannel.com/redirect.asp?u=/&s=vcnb";
  if (32 >= (int)ShellExecute(NULL, "open", strUrl, NULL, NULL, SW_SHOWNORMAL))
	{
		AfxMessageBox("::ShellExecute failed to open this link!");
	}
}

void CResizableTestDlg::OnBnClickedAppAbout()
{
  CAboutDlg().DoModal();
}

BEGIN_MESSAGE_MAP(CAboutDlg, TXResizable<CDialog>)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
  ON_BN_CLICKED(IDOK, OnBnClickedOk)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CResizableTestDlg dialog

CResizableTestDlg::CResizableTestDlg(CWnd* pParent /*=NULL*/)
	: TXResizable<CDialog>(CResizableTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CResizableTestDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

UINT CResizableTestDlg::GetResizeFlags(UINT id,CWnd* /*pControl*/,CRect& /*rcControl*/, const CSize& /*szNow*/, const CSize& /*szWas*/, const CSize& /*szIni*/, const CSize& /*szDelta*/) {
	if (id == IDOK || id == IDCANCEL) {
		return RESIZE_WIDTH_RFIX | RESIZE_HEIGHT_TFIX;
	} else if (id == IDC_EDIT1) {
		return RESIZE_LEFT_LFIX|RESIZE_RIGHT_RFIX|RESIZE_TOP_TFIX|RESIZE_BOTTOM_BFIX;
	} else if (id == IDC_CHECK1) {
		return RESIZE_LEFT_LFIX|RESIZE_RIGHT_LFIX|RESIZE_TOP_BFIX|RESIZE_BOTTOM_BFIX;
	} else {
		return RESIZE_NONE;
	}
}

void CResizableTestDlg::DoDataExchange(CDataExchange* pDX)
{
	TXResizable<CDialog>::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CResizableTestDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CResizableTestDlg, TXResizable<CDialog>)
	//{{AFX_MSG_MAP(CResizableTestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
  ON_BN_CLICKED(ID_APP_ABOUT, OnBnClickedAppAbout)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CResizableTestDlg message handlers

BOOL CResizableTestDlg::OnInitDialog()
{
	TXResizable<CDialog>::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CResizableTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		TXResizable<CDialog>::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CResizableTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		TXResizable<CDialog>::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CResizableTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
